/****************************************************************************\
*   OS_DEP - this source file is part of Binary vIEW project (BIEW)          *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1999-2000 Konstantin Boldyshev                     *
*   License:              See below                                          *
*   Author and developer: Konstantin Boldyshev                               *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/generic/unix/os_dep.c                   *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
* This file contains implementation of unix compatible OS dependent part.    *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/

#include "__os_dep.h"
#include "_sys_dep.h"
#include "biewlib.h"

#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

#define MAX_NAME 255
static char _ini_name[MAX_NAME];

char * __get_ini_name(void)
{
    char *p;

    if ((p = getenv("HOME")) == NULL || strlen(p) > MAX_NAME - 10)
	strcpy(_ini_name, "/tmp");
    else
	strcpy(_ini_name, p);

    strcat(_ini_name, "/.biewrc");

    return _ini_name;
}

char * __get_help_name(void)
{
	return "/usr/lib/biew/biew.hlp";
}

static void cleanup(int sig)
{
	__term_mouse();
	__term_keyboard();
	__term_vio();
	__term_sys();

	printm("Terminated by signal %d\n", sig);
	_exit(1);
}

void __OsYield(void)
{
/*
	usleep(10000);
*/
	struct timespec t = { 0, 100000 };
	nanosleep(&t, NULL);
}

/* static struct sigaction sa; */

void __init_sys(void)
{
	umask(0077);
	signal(SIGTERM, cleanup);
	signal(SIGINT,  cleanup);
	signal(SIGQUIT, cleanup);
	signal(SIGILL, cleanup);
/*
	sa.sa_handler = cleanup;
	sigaction(SIGTERM, &sa, NULL);
	sigaction(SIGINT, &sa, NULL);
	sigaction(SIGQUIT, &sa, NULL);
	sigaction(SIGILL, &sa, NULL);
*/
}

void __term_sys(void)
{
}
